local wk = require('which-key')

wk.add({
    { "<leader>", group = "Global Menu" },

    { "<leader>T", group = "Test" },
    { "<leader>Td", ':lua require("neotest").run.run({strategy = "dap"})<CR>', desc = "debug test" },
    { "<leader>Tf", ':lua require("neotest").run.run(vim.fn.expand("%"))<CR>', desc = "run file" },
    { "<leader>To", ':lua require("neotest").summary.open()<CR>', desc = "Open Overview/Summary" },
    { "<leader>Tr", ':lua require("neotest").run.run()<CR>', desc = "run test" },
    { "<leader>Ts", ':lua require("neotest").run.stop()<CR>', desc = "stop running test" },

    { "<leader>a", group = "Completion / LSP" },
    { "<leader>ad", ":Lspsaga hover_doc<CR>", desc = "Documentation" },
    { "<leader>ae", ":Lspsaga show_line_diagnostics<CR>", desc = "Errors: Line diagnostics" },
    { "<leader>af", ":Lspsaga code_action<CR>", desc = "Fix" },
    { "<leader>al", ':lua require("lint").try_lint()<CR>', desc = "Lint" },
    { "<leader>ao", ":Outline<CR>", desc = "Outline" },
    { "<leader>ap", ":lua vim.lsp.buf.signature_help()<CR>", desc = "Signature" },
    { "<leader>ar", ":Lspsaga rename<CR>", desc = "Rename" },
    { "<leader>at", ":Neotree filesystem reveal left<CR>", desc = "Files" },
    { "<leader>au", ":Lspsaga lsp_finder<CR>", desc = "Find usages" },

    { "<leader>c", group = "Comment Menu" },
    { "<leader>cb", group = "Comment block" },
    { "<leader>cbe", ':lua placeCharAtColumn("|", 97)<CR>', desc = "Add | at end of line" },
    { "<leader>cbl", ':lua createLine("-", 96)<CR>', desc = "Create line of dashes" },
    { "<leader>cc", ":Commentary<CR>", desc = "Comment", mode={"n", "v"}},
    { "<leader>cd", ':lua require("neogen").generate()<CR>', desc = "Docstring" },
    { "<leader>cl", ':lua placeCharAtColumn("\\\\", 97)<CR>', desc = "Continue on next line" },

    { "<leader>d", group = "Debug" },
    { "<leader>db", group = "Breakpoints" },
    { "<leader>dbb", ':lua require("dap").toggle_breakpoint()<CR>', desc = "Toggle breakpoint" },
    { "<leader>dbc", ':lua require("dap").set_breakpoint(vim.fn.input("Breakpoint condition: "))<CR>', desc = "Set conditional breapoint" },
    { "<leader>dc", ':lua require("dap").continue()<CR>', desc = "Continue" },
    { "<leader>de", ':lua require("dap").repl.open()<CR>', desc = "Evaluate (via REPL)" },
    { "<leader>di", ':lua require("dap").step_into()<CR>', desc = "Step into" },
    { "<leader>dl", ':lua require("dap.ext.vscode").load_launchjs(nil, { gdb = {"c", "cpp"}, cppdbg = {"c", "cpp"}})<CR>', desc = "Load launch js config" },
    { "<leader>dm", ':lua require("dap-python").test_method()<CR>', desc = "Test python method" },
    { "<leader>do", ':lua require("dap").step_out()<CR>', desc = "Step into" },
    { "<leader>dr", ':lua require("dap").run_to_cursor()<CR>', desc = "Run to cursor" },
    { "<leader>ds", ':lua require("dap").step_over()<CR>', desc = "Step into" },
    { "<leader>dt", ':lua require("dap").terminate()<CR>', desc = "Terminate" },
    { "<leader>du", ':lua require("dapui").toggle()<CR>', desc = "Toggle UI" },

    { "<leader>g", group = "Goto commands" },
    { "<leader>gd", ":Telescope lsp_definitions<CR>", desc = "Definition" },
    { "<leader>gh", ":ClangdSwitchSourceHeader<CR>", desc = "Switch Source and Header" },
    { "<leader>gi", ":Telescope lsp_implementations<CR>", desc = "Implentation(s)" },
    { "<leader>gp", ":Lspsaga preview_definition<CR>", desc = "Preview definition" },
    { "<leader>gr", ":Telescope lsp_references<CR>", desc = "References" },
    { "<leader>gs", ":Telescope lsp_workspace_symbols<CR>", desc = "Symbols (Workspace)" },

    { "<leader>h", "<c-w>h", desc = "Buffer right" },

    { "<leader>i", group = "Git commands" },
    { "<leader>ib", ":Telescope git_branches<CR>", desc = "Branches" },
    { "<leader>ic", ":G commit", desc = "commit" },
    { "<leader>id", ":Telescope git_status<CR>", desc = "Diff" },
    { "<leader>if", ":Telescope git_files<CR>", desc = "Files" },
    { "<leader>ih", group = "Git hunk commands" },
    { "<leader>ihn", ":GitGutterNextHunk<CR>", desc = "Next Hunk" },
    { "<leader>ihp", ":GitGutterPrevHunk<CR>", desc = "Previous Hunk" },
    { "<leader>ihs", ":GitGutterStageHunk<CR>", desc = "Stage Hunk" },
    { "<leader>ihu", ":GitGutterUndoHunk<CR>", desc = "Undo Hunk" },
    { "<leader>ihv", ":GitGutterPreviewHunk<CR>", desc = "Preview Hunk" },
    { "<leader>is", ":Neotree git_status float<CR>", desc = "Status" },
    { "<leader>j", "<c-w>j", desc = "Buffer below" },
    { "<leader>k", "<c-w>k", desc = "Buffer above" },
    { "<leader>l", "<c-w>l", desc = "Buffer left" },

    { "<leader>o", group = "Orgmode" },

    { "<leader>p", group = "CtrlP / telescope Menu" },
    { "<leader>pb", ":Telescope buffers<CR>", desc = "Buffers" },
    { "<leader>pd", ":Telescope diagnostics<CR>", desc = "Diagnostics" },
    { "<leader>pf", ":Telescope find_files<CR>", desc = "Files" },
    { "<leader>pg", ":Telescope live_grep<CR>", desc = "Grep" },
    { "<leader>pk", ":Telescope keymaps<CR>", desc = "Normal mode keymaps" },
    { "<leader>pm", ":Telescope man_pages", desc = "Man Pages" },
    { "<leader>pr", ":Telescope registers<CR>", desc = "Registers" },
    { "<leader>ps", ":Telescope spell_suggest<CR>", desc = "Spelling suggestions" },
    { "<leader>py", ':lua require("telescope.builtin").lsp_dynamic_workspace_symbols()<CR>', desc = "Symbols" },
    { "<leader>pp", ':lua require("telescope").extensions.projects.projects{}<CR>', desc = "Projects" },

    { "<leader>r", ":so ~/.config/nvim/init.lua<CR>", desc = "reload config" },
    { "<leader>s", ":wa<CR>", desc = "Save all" },
    { "<leader>t", group = "Tabs" },
    { "<leader>v", ":vsplit<CR>", desc = "Split buffer vertically" },
    { "<leader>w", group = "Windows" },
    { "<leader>wh", ":vertical res -5<CR>", desc = "Decrease Width" },
    { "<leader>wj", ":res -5<CR>", desc = "Decrease Height" },
    { "<leader>wk", ":res +5<CR>", desc = "Increase Height" },
    { "<leader>wl", ":vertical res +5<CR>", desc = "Increase Width" },
    { "<leader>ws", group = "Scale" },
    { "<leader>wsd", ":lua vim.g.neovide_scale_factor = vim.g.neovide_scale_factor * 1/1.25<CR>", desc = "Decrease" },
    { "<leader>wsi", ":lua vim.g.neovide_scale_factor = vim.g.neovide_scale_factor * 1.25<CR>", desc = "Increase" },
    { "<leader>wsr", ":lua vim.g.neovide_scale_factor = 1<CR>", desc = "reset" },
})

vim.keymap.set('t', '<C- >', '<C-\\><C-N>')
